#ifndef _HASH_SEARCH_
#define _HASH_SEARCH_

#define HASH_KEY_SIZE	30

typedef enum HashBucketStatusType { EMPTY = 0, USED, DELETED  } HashBucketStatus;

typedef struct HashBucketType {
	char key[HASH_KEY_SIZE + 1];
	int value;
	HashBucketStatus status;
} HashBucket;

typedef struct HashTableType {
	int bucketSize;
	int currentCount;
	HashBucket *pBucket;
} HashTable;

// ؽ ̺ .
HashTable* createHashTable(int bucketSize);

// ڷ ߰.
int addData(HashTable* pHashTable, HashBucket bucket);

// ڷ .
int removeData(HashTable* pHashTable, char* key);

// ڷ ˻.
HashBucket* search(HashTable* pHashTable, char* key);

// ؽ ̺  ǥ.
void displayHashTable(HashTable *pHashTable);

// ؽ ̺  ڷ .
int getCount(HashTable *pHashTable);

// ؽ ̺ .
void deleteHashTable(HashTable *pHashTable);

//  ο Ǵ Լ.
int hashFunction(char *pKey, int bucketSize);
unsigned int stringToInt(char *pKey);
int isEmptyBucket(HashBucket* pBucket);
int isEmptyOrDeletedBucket(HashBucket* pBucket);

#endif
