#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hashsearch_chain.h"

// ؽ ̺ .
HashTable* createHashTable(int bucketSize) {
	HashTable *pReturn = NULL;
    int i = 0;

	if (bucketSize <= 0) {
		printf("Ŷ ũ 0 Ŀմϴ\n");
		return NULL;
	}

	pReturn = (HashTable *)malloc(sizeof(HashTable));
	if (pReturn != NULL) {
		pReturn->bucketSize = bucketSize;
		pReturn->ppBucket = NULL;
	}
	else {
		printf(", ù° ޸Ҵ, createHashTable()\n");
		return NULL;
	}

    pReturn->ppBucket = (LinkedList **)malloc(sizeof(LinkedList*) * bucketSize);
    if (pReturn->ppBucket != NULL) {
        memset(pReturn->ppBucket, 0, sizeof(LinkedList*) * bucketSize);
        
        for(i = 0; i < bucketSize; i++) {
            pReturn->ppBucket[i] = createLinkedList();
        }
    }
    else {
        printf(", ι° malloc(), createHashTable()\n");
        return NULL;
    }
	return pReturn;
}

// ڷ ߰.
int addData(HashTable* pHashTable, HashSlot slot) {
    int ret = 0;
    LinkedList* pBucket = NULL;
    
    if (pHashTable != NULL) {
        pBucket = searchBucket(pHashTable, slot.key);
        if (pBucket != NULL) {
            addLinkedListDataLast(pBucket, slot);
            pHashTable->currentCount++;
        }
        else {
            printf(", ߸ ؽ ̺ ּҰ Ǿϴ\n");
        }
    }
    
    return ret;
}

LinkedList* searchBucket(HashTable* pHashTable, char* key) {
    LinkedList* pReturn = NULL;
    int bucketIndex = 0;
    
    if (pHashTable != NULL) {
        bucketIndex = hashFunction(key, pHashTable->bucketSize);
        if (bucketIndex >= 0) {
            pReturn = pHashTable->ppBucket[bucketIndex];
        }
        else {
            printf(", ߸ ؽ ̺ ּҰ Ǿϴ,\n");
        }
    }
    
    return pReturn;
}

int hashFunction(char *pKey, int bucketSize) {
    int ret = -1;
    unsigned int temp_key = 0;
    
    if (pKey == NULL) {
        return ret;
    }
    
    temp_key = stringToInt(pKey);
    if (bucketSize > 0) {
        ret = temp_key % bucketSize;
    }
    
    return ret;
}

// ڿ ڷ ȯ.
unsigned int stringToInt(char *pKey) {
    unsigned int ret = 0;
    while(*pKey != '\0') {
        ret = (ret * 31) + (*pKey);
        pKey++;
    }
    
    return ret;
}

// Ʈ   ߰.
int addLinkedListDataLast(LinkedList* pBucket, HashSlot data) {
    int ret = 0;
    if (pBucket != NULL) {
        int position = pBucket->currentCount;
        ret = addLinkedListData(pBucket, position, data);
    }
    return ret;
}

// ڷ ˻.
HashSlot* search(HashTable* pHashTable, char* key) {
	HashSlot* pReturn = NULL;
    LinkedList* pList = NULL;
    int position = 0;
    
    pList = searchBucket(pHashTable, key);
    if (pList != NULL) {
        pReturn = searchSlot(pList, key, &position);
    }

	return pReturn;
}

HashSlot* searchSlot(LinkedList* pList, char* key, int* pPosition) {
    HashSlot* pReturn = NULL;
    LinkedListNode* pSlot = NULL;
    int index = 0;
    
    if (pList != NULL && pPosition != NULL) {
        pSlot = pList->headerNode.pLink;
        
        while(pSlot != NULL) {
            if (strcmp(pSlot->data.key, key) == 0) {
                pReturn = &(pSlot->data);
                *pPosition = index;
                break;
            }
            pSlot = pSlot->pLink;
            index++;
        }
        if (pReturn == NULL) {
            printf("˻ , ˻Ű-[%s]  ʽϴ\n", key);
        }
    }
    
    return pReturn;
}

// ڷ .
int removeData(HashTable* pHashTable, char* key) {
	int ret = 0;
	HashSlot *pSlot = NULL;
    LinkedList* pList = NULL;
    int position = 0;
    
    pList = searchBucket(pHashTable, key);
    if (pList != NULL) {
        pSlot = searchSlot(pList, key, &position);
        if (pSlot != NULL) {
            removeLinkedListData(pList, position);
            pHashTable->currentCount--;
            ret = 1;
        }
    }

	return ret;
}

// ؽ ̺ .
void deleteHashTable(HashTable *pHashTable) {
    int i = 0;
    if (pHashTable != NULL) {
        if (pHashTable->ppBucket != NULL) {
            for(i = 0; i < pHashTable->bucketSize; i++) {
                deleteLinkedList( pHashTable->ppBucket[i] );
            }
            free(pHashTable->ppBucket);
        }
        free(pHashTable);
    }
}

// ؽ ̺  ڷ .
int getCount(HashTable *pHashTable) {
	int ret = 0;

	if (pHashTable != NULL) {
		ret = pHashTable->currentCount;
	}

	return ret;
}

// ؽ ̺  .
void displayHashTable(HashTable *pHashTable) {
    int i = 0, j = 0;
    int slotSize = 0;
    LinkedList* pList = NULL;
    LinkedListNode* pNode = NULL;
    
    if (pHashTable != NULL) {
        for(i = 0; i < pHashTable->bucketSize; i++) {
            printf("[%d]", i);
            
            pList = pHashTable->ppBucket[i];
            slotSize = getLinkedListLength( pList );
            if (slotSize == 0) {
                printf(",Empty \n");
            }
            else {
                pNode = pList->headerNode.pLink;
                for(j = 0; j < slotSize; j++) {
                    printf(",(%s, %d) ", pNode->data.key, pNode->data.value);
                    pNode = pNode->pLink;
                }
                printf("\n");
            }
        }
    }
}
